/***************************************************************************
 *   Copyright (C) 2005 by Siraj Razick                                    *
 *   siraj@kdemail.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "kbfxconfig.h"


//Note: these are some things for kbfx 0.5. later Akh and I shall merge these with new kcontrol module


KbfxConfig::KbfxConfig()
{
//TODO
read();
}


KbfxConfig& ConfigInit()
{
	static KbfxConfig _config;
	return _config;
}


void KbfxConfig::read()
{

 confskel= new KConfigSkeleton( QString::fromLatin1( "kbfxrc" ));
 
 KConfig * conf = confskel->config();
 QString __default  = KGlobal::iconLoader()->iconPath("kbfx",(int)KIcon::Desktop,false);
 conf->setGroup("KbfxButton");
        KIconLoader *iconload = KGlobal::iconLoader ();
        QString path = iconload->iconPath (QString ("normal"), KIcon::Desktop, false);
	path.remove("normal.png");
//	qDebug("Path ==ICON ++>>"+path);
	m_KbfxNormalButtonPath = conf->readEntry  ("Normal",path+"/normal.png");
 	m_KbfxHoverButtonPath = conf->readEntry   ("Hover",path+"/hover.png");
 	m_KbfxPressedButtonPath = conf->readEntry ("Press",path+"/pressed.png");
	m_KbfxMenuType = conf->readEntry("MenuType","spinx");
 conf->setGroup("SpinxBar");
	m_SpinxThemeBasePath = conf->readEntry("ThemePath","");	
	m_SpinxDudeBlink  = conf->readBoolEntry("DudeBlink",false);	
	m_SpinxThemeName  = conf->readEntry("ThemeName","");	
 conf->setGroup("ToolTip");
	m_ToolTip = conf->readBoolEntry("EnableToolTip",true);
	m_ToolTipAnimation = conf->readBoolEntry("AnimatedTooltip",true);
	m_ToolTipText      = conf->readEntry("ToolTipText","Application Menu");
//get butterly
        iconload = KGlobal::iconLoader ();
        path = iconload->iconPath (QString ("butterfly"), KIcon::Desktop, false);
	m_ToolTipAvatar    = conf->readEntry("ToolTipAvatar",path);
  conf->setGroup("runtime");
        m_KbfxHistory = conf->readEntry("History","");		

//get some font settings from the theme file
	KConfig * fontconfig = new KConfig(m_SpinxThemeBasePath+"/"+m_SpinxThemeName+"/kbfxfontrc");
//	qDebug("reading Font Settings new    "+m_SpinxThemeBasePath+m_SpinxThemeName+"/kbfxfontrc");
/*
 QColor m_fontAppNameColor;
        QColor m_fontAppCommentColor;
        QColor m_lineColor;
        QColor m_fontIndexColor;
        uint   m_fontSize;
*/
	fontconfig->setGroup("fonts");
         m_fontAppNameColor  = fontconfig->readColorEntry("ApplicationText",new QColor(0,0,0));
	 m_fontAppCommentColor = fontconfig->readColorEntry("CommentText",new QColor(128,125,0));
	 m_lineColor    = fontconfig->readColorEntry("LineColor",new QColor(255,220,125));
	 m_fontIndexColor  = fontconfig->readColorEntry("GroupText",new QColor(0,0,0));
	 m_fontSize = fontconfig->readNumEntry("FontSize",8);
	 m_userNameColor = fontconfig->readColorEntry("UserName",new QColor(255,255,255));

 

      	
}


void KbfxConfig::write()
{
 KConfigSkeleton    *confskel= new KConfigSkeleton( QString::fromLatin1( "kbfxrc" ));
    // write general options
    KConfig * conf = confskel->config();
  conf->setGroup("KDE Action Restrictions");
    conf->writeEntry("warn_unwritable_config",false);

  conf->setGroup("KbfxButton");
    conf->writeEntry("Normal", m_KbfxNormalButtonPath);
    conf->writeEntry("Hover",m_KbfxHoverButtonPath);
    conf->writeEntry("Press",  m_KbfxPressedButtonPath);
    conf->writeEntry("MenuType",m_KbfxMenuType);
 conf->setGroup("SpinxBar");
    conf->writeEntry("ThemePath",m_SpinxThemeBasePath);
    conf->writeEntry("DudeBlink",m_SpinxDudeBlink); 
    conf->writeEntry("ThemeName",m_SpinxThemeName); 
   
  conf->setGroup("ToolTip");
    
    conf->writeEntry("AnimatedTooltip",m_ToolTipAnimation);
    conf->writeEntry("EnableToolTip",m_ToolTip);
    conf->writeEntry("ToolTipText",m_ToolTipText);
    conf->writeEntry("ToolTipAvatar",m_ToolTipAvatar);
    
   conf->setGroup("runtime");
    conf->writeEntry("History",m_KbfxHistory);
    conf->sync();


	KConfig * fontconfig = new KConfig(m_SpinxThemeBasePath+"/"+m_SpinxThemeName+"/kbfxfontrc");
	fontconfig->setGroup("fonts");
	fontconfig->writeEntry("UserName",m_userNameColor);
	fontconfig->writeEntry("ApplicationText",m_fontAppNameColor);
	fontconfig->writeEntry("GroupText", m_fontIndexColor );
	fontconfig->sync();
}

void KbfxConfig::setNormalButtonPath(QString path)
{
if(!path.isNull())
m_KbfxNormalButtonPath = path;
}

void KbfxConfig::setHoverButtonPath(QString path)
{
if(!path.isNull())
m_KbfxHoverButtonPath = path;
}

void KbfxConfig::setPressedButtonPath(QString path)
{
if(!path.isNull())
	m_KbfxHoverButtonPath = path;
}

